/* CSFsmResponseModule \- Transition module short description
   banner = -----------

   Name: CSFsmResponseModule.cc

modification history
--------------------
rti,26Jun97,xxx Skeleton generated

DESCRIPTION:

   Skeleton code segment for the CSFsmResponseModule transition module.
   Generated automatically by the ControlShell FSM Editor.

   Do not modify by hand!
   This file should be copied to CSFsmResponseModule.cc, 
   and the copy edited to suit your application.

FSM ENTRY FORMAT:

       context;                 "<String>"


EXAMPLE:

   <none>
========================================================================== */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "rtilib/makeheader.h"
#include "cs.h"
#include "CSFsm.h"

#pragma begin_Package
#ifdef RET_OK
#undef RET_OK
#endif /* RET_OK */
#define RESPOND(retCode) respond(retCode)
#pragma end_Package

/* Additional Include Files, including your .fsm.h file for return codes */
#include "response.fsm.h"
#include "CSFsmResponder.h"

Public typedef class CSFsmResponseModuleClass *CSFsmResponseModule;

Package
class CSFsmResponseModuleClass : public TransRtnModuleClass {

friend class CSFsmResponseModuleParseClient;
  public:
    enum RETCODE {
	RET_OK,
    };

  private:
    /* Additional private members and methods */

  protected:
    String                  _context;

    /* Additional protected members and methods */

  public:
    CSFsmResponseModuleClass( CSFsm fsm,  const char *modulename );
    ~CSFsmResponseModuleClass();

    virtual int execute();

    virtual int getRetcode( char *retcodeName );
    virtual boolean print( int verbosity );
    virtual void *instance();

    /* Additional public routines */

    virtual const char *const className() { return ("CSFsmResponseModule"); }

  void setContext (String context) { _context = context; }
  int respond (int retCode);
};

CSFsmResponseModuleClass::CSFsmResponseModuleClass( CSFsm fsm, const char *modulename )
    : TransRtnModuleClass(fsm, modulename)
{
    /* Additional initialization code goes here. */
  _context = "";
}

CSFsmResponseModuleClass::~CSFsmResponseModuleClass()
{
    /* Your destructor code goes here */
}

/* 
 * This is the CSFsmResponseModule transition module's main routine.  
 * It is called by the Finite State Machine.
 *
 * This should return the appropriate RETCODE return codes.
 */
int CSFsmResponseModuleClass::execute()
{
    return respond(RET_OK);
}

/*  
 * CSFsmResponseModuleClass::instance \- CSFsmResponseModule Instancing Routine
 *
 * This is called when a new instance of a CSFsmResponseModule 
 * is to be created and installed into the system. 
 *
 * If error, return NULL
 */
void *CSFsmResponseModuleClass::instance()
{
    /* Your instancing code goes here */

    return(this);
}

/*  
 * CSFsmResponseModuleClass::respond
 *
 * This is called to issue a response when an FSM transition occurs.
 * Always returns the retCode (so you can say "return respond(RET_OK);" )
 */
int CSFsmResponseModuleClass::respond (int retCode)
{
  CSFsmResponder responder, next, last;
  boolean isNoStimModule;
  String stimulus = NULL;

  isNoStimModule = (!strcmp(this->_context, NO_STIM_MODULE));
  if (isNoStimModule) {
    stimulus = (String)(this->_fsm->StimulusGetLast());
    fprintf(stderr, "%s: %s\n", NO_STIM_MODULE, stimulus);
    retCode = CSFSM_IGNORE_RETCODE;
  }
  responder = (CSFsmResponder)(_fsm->UserData());
  if (responder) {
    last = NULL;
    do {
      next = responder->getNext();
      if ((isNoStimModule
	   ? responder->missingStimulus(stimulus)
	   : responder->respond(_context, retCode))) {
	if (last) 
	  last->setNext(next);
	else 
	  _fsm->UserData((void *)next);
	delete responder;
      } else {
	last = responder;
      }
      responder = next;
    } while (responder);
  }
  return retCode;
}

Package
void CSFsmResponseModuleInitialize()
{
    /* Your initialization code for the entire class goes here. */
}


/* End of file */
